import { select,csv,mean } from 'd3';

// let data = csv("data.csv",d=>{
// 	d.measure = +d.measure;
//   return d.measure;
// })
function calculateMR(arr){
  let result = [0],i,mr = arr[0];
  for (i = 1; i <arr.length; i++) {
     result.push(Math.abs(arr[i] - mr));
    	mr = arr[i]
	}
  return result;
}
const pointsAboveSigma = (minElem,avg,ravg,alpha) =>{
  if ((minElem - avg) > ravg * alpha)
    return true;
  else
    return false;
  // alpha 1.98
  // alpha 1.08
}
const calculateMinimum = (i,gap,top12Measures) =>{
  let max = i+1;
  let min = max-gap<0?0:max-gap;
  let sliceArr = top12Measure.slice(min,max)
  return Math.min(...sliceArr)
}
function calculateBreakPoint(top12Measure,avg,ravg){
  for(let i = 0; i<12;i++){
    let minElem2 = calculateMinimum(i,2,top12Measure);
    let result1 = pointsAboveSigma(minElem2,avg,ravg,1.98) //two points above 2 sigma
    let minElem3 = calculateMinimum(i,3,top12Measure)    
    let result2 = pointsAboveSigma(minElem3,avg,ravg,1.08) // three points above 1 sigma
    if(result1 || result2)
      return i
    
  }
	
}
let lowerBound;
let upperBound;
let data= [24, 25, 26, 26, 25, 26, 27, 28, 29, 30, 31, 30, 35, 35, 36, 35, 34, 33, 34, 36, 37, 38, 40, 37, 41, 40, 42, 41, 41, 45, 46, 43, 45, 47, 49, 47, 45, 47, 52];
let top12Measure = data.slice(0,12);
let mr = calculateMR(top12Measure);
let avg = mean(top12Measure)
let ravg = mean(mr);
console.log(avg,ravg) //average /12 not 11 for first case
let breakpoint = calculateBreakPoint(top12Measure,avg,ravg)
